---
name: Bug report
about: Report a bug
title: bug
labels: bug
assignees: ''
---

**WARNING: Please, read this note carefully before submitting a new bug:**

It is important to realize that **this is NOT A SUPPORT FORUM**, this is for reproducible BUGS ONLY.

If you need support, have questions, ideas to discuss you should use
the [Nelua Discussions](https://github.com/edubart/nelua-lang/discussions) forum or
the [Nelua Discord server](https://discord.gg/7aaGeG7).

Please, before submitting a new issue, verify the following:
 - You have tested it on latest Nelua version from master branch.
 - You have checked that there is no similar issue already reported.
 - You have checked that your code has no errors or misuse of Nelua.

---

### Bug description

A clear and concise description of the bug you are experiencing.
Tell what you were trying to do and what happened instead.

### Code example

Provide minimal reproduction code to test the bug.
Please, format the code properly and try to keep it as simple as possible, just focusing on the experienced bug.

```lua
-- Place the Nelua code here.
```

### Expected behavior

A clear and concise description of what you expected to happen.

### Workaround

If you have already found a way to workaround the issue,
then please share how you did it,
this may help others with the same issue.

### Environment

Provide relevant information about your environment:
 - Nelua version (you can check with `nelua -v`).
 - Platform (e.g. Windows/MSYS2, Ubuntu Linux, MacOS)
 - Architecture (e.g. x86_64, arm64)
 - C compiler if your bug has C compiler errors. (e.g. GCC 10.2, Clang 11)
